version: '3.7'

services:
  server:
    build: ./teams-api
    ports:
      - 7987:3000
    volumes:
      # - ./data/deps:/usr/src/app/node_modules
      - ./teams-api/src:/usr/src/app/src
    depends_on:
      - cache
      - broker
    environment:
      BROKER_URL: nats://broker:4222
      BROKER_CLUSTER_ID: broker
      CACHE_URL: mongodb://cache:27017
      DB_NAME: devdb

  sink:
    build: ./teams-sink
    environment:
      BROKER_URL: nats://broker:4222
      BROKER_CLUSTER_ID: broker
      CACHE_URL: mongodb://cache:27017
      CACHE_DB: devdb
    depends_on:
      - broker
      - cache
    volumes:
      # - ./data/deps:/usr/src/app/node_modules
      - ./teams-sink/src:/usr/src/app/src

  cache:
    image: mongo:4.2.6-bionic
    volumes: 
      - ./data/mongo:/data/db

  broker:
    image: nats-streaming:0.17.0-linux
    command: --cluster_id broker -m 8222 --store FILE --dir /usr/src/app/broker
    volumes:
      - ./data/dlake:/usr/src/app/broker
    ports:
      - 7986:8222
    depends_on:
      - cache